package space.rocketnine.fastingassistant;

import android.app.Activity;
import android.app.AlarmManager;
import android.app.Application;
import android.app.PendingIntent;
import android.content.Context;
import android.content.Intent;
import android.content.SharedPreferences;
import android.net.Uri;
import android.os.Build;
import android.preference.PreferenceManager;
import android.util.Log;

public class FastingAssistant extends Application {
    public static String LOG_TAG = "FastingAssistant";

    public static int REQUEST_ID = 1990;
    public static int NOTIFICATION_ID = 1990;

    public static String ACTION_FAST_STARTED = "space.rocketnine.fastingassistant.FAST_STARTED";
    public static String ACTION_FAST_COMPLETED = "space.rocketnine.fastingassistant.FAST_COMPLETED";

    public static String URL_ROCKETNINELABS = "https://rocketnine.space";
    public static String URL_SOURCE = "https://code.rocketnine.space/tslocum/fastingassistant";

    public static String URL_RESOURCE_WIKI = "https://old.reddit.com/r/intermittentfasting/wiki/index";
    public static String URL_RESOURCE_FAQ = "https://old.reddit.com/r/intermittentfasting/wiki/faq";
    public static String URL_RESOURCE_STUDIES = "https://old.reddit.com/r/intermittentfasting/wiki/studies";
    public static String URL_RESOURCE_SUBREDDIT = "https://old.reddit.com/r/intermittentfasting/";

    private AlarmManager alarmManager;

    public AlarmManager getAlarmManager() {
        if (alarmManager == null) {
            alarmManager = (AlarmManager) getSystemService(Context.ALARM_SERVICE);
        }
        return alarmManager;
    }

    public void setAlarm(long triggerAtMillis, PendingIntent pendingIntent) {
        if (Build.VERSION.SDK_INT >= 19) {
            getAlarmManager().setExact(AlarmManager.RTC_WAKEUP, triggerAtMillis, pendingIntent);
        } else {
            getAlarmManager().set(AlarmManager.RTC_WAKEUP, triggerAtMillis, pendingIntent);
        }
        Log.d(LOG_TAG, "Set alarm at " + triggerAtMillis + " for " + pendingIntent);
    }

    SharedPreferences prefs;

    public SharedPreferences getPrefs() {
        if (prefs == null) {
            prefs = PreferenceManager.getDefaultSharedPreferences(getApplicationContext());
        }
        return prefs;
    }

    public static void openURL(Activity activity, String url) {
        Intent defaultBrowser = Intent.makeMainSelectorActivity(Intent.ACTION_MAIN, Intent.CATEGORY_APP_BROWSER);
        defaultBrowser.setData(Uri.parse(url));
        activity.startActivity(defaultBrowser);
    }
}
