package space.rocketnine.fastingassistant.ui.home;

import android.os.Bundle;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.TextView;

import androidx.annotation.NonNull;
import androidx.fragment.app.Fragment;
import androidx.lifecycle.ViewModelProvider;

import space.rocketnine.fastingassistant.FastingAssistant;
import space.rocketnine.fastingassistant.databinding.FragmentHomeBinding;

public class HomeFragment extends Fragment {

    private FragmentHomeBinding binding;

    public View onCreateView(@NonNull LayoutInflater inflater,
                             ViewGroup container, Bundle savedInstanceState) {
        HomeViewModel homeViewModel =
                new ViewModelProvider(this).get(HomeViewModel.class);

        binding = FragmentHomeBinding.inflate(inflater, container, false);
        View root = binding.getRoot();

        final TextView textView = binding.textHome;
        homeViewModel.getText().observe(getViewLifecycleOwner(), textView::setText);

        // Make resource links clickable.
        final TextView resourceWiki = binding.fastingResourceWiki;
        resourceWiki.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                FastingAssistant.openURL(getActivity(), FastingAssistant.URL_RESOURCE_WIKI);
            }
        });
        final TextView resourceFAQ = binding.fastingResourceFAQ;
        resourceFAQ.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                FastingAssistant.openURL(getActivity(), FastingAssistant.URL_RESOURCE_FAQ);
            }
        });
        final TextView resourceStudies = binding.fastingResourceStudies;
        resourceStudies.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                FastingAssistant.openURL(getActivity(), FastingAssistant.URL_RESOURCE_STUDIES);
            }
        });
        final TextView resourceSubreddit = binding.fastingResourceSubreddit;
        resourceSubreddit.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                FastingAssistant.openURL(getActivity(), FastingAssistant.URL_RESOURCE_SUBREDDIT);
            }
        });

        return root;
    }

    @Override
    public void onDestroyView() {
        super.onDestroyView();
        binding = null;
    }
}